/*
 *				**** DEMO.H ****
 *
 * This file contains global declarations and definitions for the
 *	C Language demo program
 *
 */

	/* get I/O definitions */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/*
 * NOTE:
 *
 *	The following is a dirty trick that I use all the time.
 *	If you don't understand what is going on, don't worry.
 *	If you set up your header file like this, and declare all
 *		global variables as EXTERN, then the file define.c
 *		will create the actual global variables, and this
 *		file can be used by all the source files
 *
 */

#ifndef EXTERN
#define EXTERN	extern
#endif

#define MAXPEOPLE	100		/* maximum number of people */
#define	IDSIZE		9		/* size of user ID field */

/* the following defines are for use with p_flag in person structure */

#define	P_EMPTY	0		/* person structure entry is empty */
#define P_DEL	1		/* person structure entry is deleted */
#define P_USED	2		/* person structure entry is in use */
 

struct date_str {		/* structure for a date */
	int		date_yr;	/* year */
	int		date_mon;	/* month */
	int		date_day;	/* day */
};

struct person {
	int		p_flag;				/* usage flag */
	char	p_id[IDSIZE];		/* user ID field */
	char	*p_lname;			/* last name of person */
	char	*p_fname;			/* first name of person */
	char	*p_addr;			/* street address of person */
	char	*p_city;			/* city */
	char	*p_state;			/* state */
	char	*p_zip;				/* zip code */
	struct date_str p_bday;		/* date of birth */
};


EXTERN	int	debugsw;			/* debugging switch */

EXTERN	struct	person people[MAXPEOPLE];	/* structure of people */
EXTERN	int	persons;			/* number of persons in structure */

void do_struct(char *);
void do_args(char *);
void do_boolean(char *);
void do_math(char *);
void do_ptr(char *);
void do_srch(char *);
void do_pointers(char *name);
int atohex(char *);
void do_help(char *);
void help_init(char *fname);
void help(char *subj);
void help_close(void);
void do_continue(void);

