/*
 *				**** DO ARGS ****
 *
 * This file contains routines to experiment with routine arguments
 *
 */

#include "demo.h"

void do_args(char *name);
void do_arg1(int i1, int *i2, char c1, char *c2, char *s1, char **s2);
int newval(char *lbl,char *buf);


void
do_args(char *name)
{		/* experiment with arguments */
	char	buf[BUFSIZ];		/* input buffer */

	/* arguments for subroutine */
	int		int1, int2;			/* integer arguments */
	char	chr1, chr2;
	char	str1[BUFSIZ], str2[BUFSIZ];

	if (debugsw) printf("Entering do_args, arg is >>%s<<\n", name);

   printf("Hello, %s, and welcome to the Arguments routine\n", name);

   /* initialize arguments to somethign meaningful */
   int1 = 1;
   int2 = 2;
   chr1 = 'a';
   chr2 = 'b';
   strcpy(str1, "string 1");
   strcpy(str2, "string 2");

	do
	{		/* display menu */
   	printf("\nOptions for Argument routine:\n");
		printf("Q\treturn to main menu.\n\n");
		printf("D\tDisplay the current values.\n");
		printf("V\tEdit the current values.\n");
		printf("C\tCall the subroutine.\n");
		printf("?\tDisplay a help message.\n");

		printf("\nOption: ");

		gets(buf);

		switch(buf[0])
		{		/* process option */
			case 'C':
			case 'c':		/* call routine */
				do_arg1(int1,&int2,chr1,&chr2,str1,&str2);
            printf("Back in original argument routine.\n");
            do_continue();
				break;

			case 'D':
			case 'd':		/* display status */
				printf("Var.\tAddr.\tValue\n");
				printf("int1\t%#x\t%d\n", &int1, int1);
				printf("int2\t%#x\t%d\n", &int2, int2);
				printf("chr1\t%#x\t%c (%#x)\n", &chr1, chr1, chr1);
				printf("chr2\t%#x\t%c (%#x)\n", &chr2, chr2, chr2);
				printf("str1\t%#x\t%s\n", &str1, str1);
				printf("str2\t%#x\t%s\n", &str2, str2);
				break;

			case 'V':
			case 'v':		/* edit values */
				if (newval("int1",buf)) int1 = atoi(buf);
				if (newval("int2",buf)) int2 = atoi(buf);
				if (newval("chr1",buf)) chr1 = buf[0];
				if (newval("chr2",buf)) chr2 = buf[0];
				if (newval("str1",buf)) strcpy(str1,buf);
				if (newval("str2",buf)) strcpy(str2,buf);
				break;

			case '?':		/* help msg */
				help("args");
				break;

			case 'q':		/* quit */
			case 'Q':
				break;

			default:
				printf("Invalid option (%s)  Try again!\n", buf);
		}
	} while (buf[0] != 'q' && buf[0] != 'Q');
}

void
do_arg1(int i1,int *i2,char c1,char *c2,char *s1,char **s2)
{		/* experiment with arguments */
	char	buf[BUFSIZ];		/* input buffer */

   printf("Entering called routine ...\n");

	do
	{		/* keep asking for options */
   	printf("\nOptions for setting arguments:\n");
		printf("Q\tReturn to argument menu.\n\n");
		printf("D\tDisplay argument values.\n");
		printf("V\tChange the values of the arguments.\n");
		printf("?\tDisplay a help message.\n");

		printf("\nOption: ");
		gets(buf);

		switch (buf[0])
		{		/* process option */
			case 'q':
			case 'Q':
				break;

			case 'D':
			case 'd':	/* display */
				printf("Var.\tAddr\tValue\n");
				printf("i1\t%#x\t%d\n", &i1, i1);
				printf("i2\t%#x\t%d\n", i2, *i2);
				printf("c1\t%#x\t%c (%#x)\n", &c1, c1, c1);
				printf("c2\t%#x\t%c (%#x)\n", c2, *c2, *c2);
				printf("s1\t%#x\t%s\n", &s1, s1);
				printf("s2\t%#x\t%s\n", s2, s2);
				break;

			case 'v':
			case 'V':
				if (newval("i1",buf)) i1 = atoi(buf);
				if (newval("i2",buf)) *i2 = atoi(buf);
				if (newval("c1",buf)) c1 = buf[0];
				if (newval("c2",buf)) *c2 = buf[0];
				if (newval("s1",buf)) strcpy(s1,buf);
				if (newval("s2",buf)) strcpy(*s2,buf);
				break;

			case '?':
				help("argset");
				break;

			default:
				printf("Invalid option (%s)\n", buf);
		}
	} while (buf[0] != 'q' && buf[0] != 'Q');
}

int
newval(char *lbl,char *buf)
{		/* get new value */
	if (debugsw)
	{		/* debugging - show all */
		printf("Entering newval.\n");
		printf("\tlbl (at %x) >>%s<<\n", &lbl, lbl);
		printf("\tbuf (at %x) >>%s<<\n", &buf, buf);
	}

	printf("New value for %s\nor press ENTER to leave alone: ", lbl);
	gets(buf);

	if (buf[0] == '\0') return 0;
	return 1;
}
