/*
 *				**** DO ARITH ****
 *
 * This file contains experiments with arithmetic
 *
 */

#include "demo.h"

double	atof();		/* function to convert string to floating point */

void do_math(char *);
void a_examples(void);
void p_examples(void);
int  new_val(char *, int);
void s_examples(void);

void
do_math(char *name)
{		/* perform arithmetic operations */
	char	buf[BUFSIZ];

	if (debugsw) printf("Entering do_math, arg is >>%s<<\n", name);

	do
	{		/* present menu */
		printf("Q\treturn to main menu.\n\n");
		printf("E\tdisplay examples of arithmetic operations.\n");
		printf("P\tExperiment with operator precedence.\n");
		printf("S\tExperiment with static and automatic variables.\n");
		printf("?\tDisplay a help message.\n");

		printf("\nOption: ");
		gets(buf);

		switch(buf[0])
		{		/* process option */
			case 'q': case 'Q': break;
			case 'e': case 'E': a_examples(); break;
			case 'p': case 'P': p_examples(); break;
			case 's': case 'S': s_examples(); break;
			case '?': help("math"); break;
			default:
				fprintf(stderr,"%s: %s is not a valid option!\n", name, buf);
		}
	} while (buf[0] != 'q' && buf[0] != 'Q');
}

void
a_examples(void)
{		/* arithmetic examples */
	char	buf[BUFSIZ];	/* input buffer */
	int		a = 2;
	int		b = 3;
	float	x = 2;
	float	y = 3;

   if (debugsw) puts("Entering a_examples, no arguments");

	do
	{	/* loop until done */
		printf("Integer variables: a=%d, b=%d.\n", a, b);
		printf("Float variables: x=%f, y=%f.\n", x, y);

		printf("a+b=%d, a-b=%d, a*b=%d", a+b, a-b, a*b);
		if (b) printf(", a/b=%d, a%%b=%d\n", a/b, a%b);
		else printf("\nCan't divide by zero!\n");

		printf("x+y=%f, x-y=%f, x*y=%f", x+y, x-y, x*y);
		if (y != 0.0) printf(", x/y=%f\n", x/y);
		else printf("\nCan't divide by zero!\n");

		printf("\nAgain (y or n): ");
		gets(buf);
		if (buf[0] == 'n' || buf[0] == 'N') break;

		printf("Press just ENTER to leave values alone.\n");
		printf("Enter new value for a (%d): ", a);
		gets(buf);
		if (buf[0] != '\0') a = atoi(buf);

		printf("Enter new value for b (%d): ",b);
		gets(buf);
		if (buf[0] != '\0') b = atoi(buf);

		printf("Enter new value for x (%f): ",x);
		gets(buf);
		if (*buf) x = atof(buf);

		printf("Enter new value for y (%f): ",y);
		gets(buf);
		if (*buf) y = atof(buf);
	} while (*buf != 'n' && *buf != 'N');

}

void
p_examples(void)
{		/* experiment with operator precedence */
	char	buf[BUFSIZ];	/* for responses from user */
	int		a = 2;
	int		b = 3;
	int		c = 4;

   if (debugsw) puts("Entering p_examples, no arguments");

	while (1)
	{		/* loop until done */
		printf("a = %d, b = %d, c = %d\n", a, b, c);
		printf("a + b * c = %d\n", a+b*c);
		printf("a * b + c = %d\n", a*b+c);
		printf("-a * b + c = %d\n", -a*b+c);
		printf("(a + b) * c = %d\n", (a+b)*c);
		printf("a + (b * c) = %d\n", a+(b*c));
		printf("a + b / c = %d\n", a+b/c);
		printf("(a + b) / c = %d\n", (a+b)/c);

		printf("\nAgain (y or n): ");
		gets(buf);
		if (*buf == 'n' || *buf == 'N') break;

		printf("Press ENTER to leave value(s) alone.\n");
		a = new_val("a",a);
		b = new_val("b",b);
		c = new_val("c",c);
	}

}

/*
 *				**** STATIC EXAMPLES ****
 *
 * This routine contains an automatic and static integer variable
 * Each time it is entered, both variables are incremented
 */

void
s_examples(void)
{		/* work with static and automatic variables */
	static	int	Static=0;
	int	Auto=0;

	printf("Entering function: Static=%d, Auto=%d\n", Static, Auto);
	Static++;
	Auto++;
	printf("After incrementing, Static=%d, Auto=%d\n", Static, Auto);

	if (Static == 1) printf("Make sure you try this option again.\n");
}

/*
 *				**** NEW VAL ****
 *
 * This routine prompts the user for a new (integer) value.
 * If the user enteres something, it is converted to integer
 * and returned; otherwise, the original value is returned.
 *
 * Arguments are:
 *   name - the name of the variable to be changed
 *   val  - the current value of the variable
 */

int
new_val(char *name, int val)
{		/* get (possibly new) value for variable */
	char	buf[BUFSIZ];
	int		ret;

	printf("Enter new value for %s (%d): ", name, val);
	gets(buf);
	if (*buf) ret = atoi(buf); /* something was entered */
	else ret = val;				/* return original value */

	return ret;
}

