/*
 *				**** EVENT ****
 *
 * This program is an example of a simple event driven
 * program.  A real event driven program would be much
 * more complex, and might even have several programs
 * running at the same time and 'talking' to each other
 *
 * THIS PROGRAM WILL ONLY RUN UNDER MS-DOS
 * It uses the ms-dos call 'getch' which will get a
 * single character from the console
 */

 #include <stdio.h>
 #include <stdlib.h>
 #include <dos.h>
 #include <conio.h>

 /*
  * Global Variables
  */

int running = 1;	/* switch indicating we are running */

 main()
 {
	int ch;		/* keyboard character */
 	int cnt=0;	/* times through loop */

 	while (running)
   { /* loop until done */
   	/* check for a character being pressed */
      if (kbhit())
      { /* key is pressed */
   		ch = getch();	/* get character */
         if (ch > 0)
         { /* regular key was pressed */
         	printf("%4.4d Key %x (%c) was pressed\n", cnt, ch, ch);
         }
         else
         { /* special key - find out which one */
         	ch = getch();	/* get special key number */
            printf("%4.4d Special key %d was pressed\n", cnt, ch);
         }
      }
      else
      {
      	printf("%4.4d No key was pressed\n", cnt);
      }
      cnt++;
      if (cnt > 5000) running = 0;	/* max times */
      sleep(1);	/* slow things down */
   }
 }
