/*
 *				**** EVENT ****
 *
 * This program is an example of a simple event driven
 * program.  A real event driven program would be much
 * more complex, and might even have several programs
 * running at the same time and 'talking' to each other
 *
 * THIS PROGRAM WILL ONLY RUN UNDER MS-DOS
 * It uses the ms-dos call 'getch' which will get a
 * single character from the console
 */

 #include <stdio.h>
 #include <stdlib.h>
 #include <dos.h>
 #include <conio.h>

 #include "fkeys.h"

 int get_key(void);

 /*
  * Global Variables
  */

int running = 1;	/* switch indicating we are running */

 main()
 {
	int ch;		/* keyboard character */
 	int cnt=0;	/* times through loop */

 	while (running)
   { /* loop until done */
   	ch = get_key();
      if (ch > 0)
      {
      	if (ch < 256)
         {
   			printf("%4.4d Key %x (%c) was pressed\n", cnt, ch, ch);
         }
         else
         {
         	printf("%4.4d Special key %d (%x)was pressed\n", cnt, ch, ch);
         }
      }
      else printf("%4.4d No key was pressed\n", cnt);

      cnt++;
      if (cnt > 5000) running = 0;	/* max times */
      sleep(1);	/* slow things down */
   }
 }

 /*
  * Determine if a key has been pressed and return
  * its code.  If no key, return negative
  */
int
get_key(void)
{
	int c;

   /* if no key is present, return -1 */
   if (!kbhit()) return NOKEY;	/* no key present */

   /*
    * A key was pressed - get scancode
    * If a special key, return the next scancode
    * shiften into the second byte
    */
	c = getch();
	if (c == 0)
	{ /* special key - multiply scan code by X'100' */
		c = getch();	/* special key scancode */
		c <<= 8;			/* shift (multiply) */
	}

	return c; /* return key code */
}
